package assignment5_2012;

import java.io.Serializable;

public class Region implements Serializable {

	private String name;
	
	private int birthRate;
	
	private int deathRate;
	
	private int migrationBalance;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		if ( name == null || name.length() < 2 )
			throw new DemographyException("Error! Invalid value for the name attribute");
		this.name = name;
	}

	public int getBirthRate() {
		return birthRate;
	}

	public void setBirthRate(int birthRate) {
		this.birthRate = birthRate;
	}

	public int getDeathRate() {
		return deathRate;
	}

	public void setDeathRate(int deathRate) {
		this.deathRate = deathRate;
	}

	public int getMigrationBalance() {
		return migrationBalance;
	}

	public void setMigrationBalance(int migrationBalance) {
		this.migrationBalance = migrationBalance;
	}
	
	public int getChangeInPopulation() {
		return birthRate + migrationBalance - deathRate;
	}

	@Override
	public String toString() {
		return "Region [name=" + name + ", birthRate=" + birthRate + ", deathRate=" + deathRate + ", migrationBalance="
				+ migrationBalance + ", change in population=" + getChangeInPopulation() + "]";
	}
	
	
	
	
}
