package assignment5_2012;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTextArea;
import java.awt.Dimension;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

public class RegionsGUI extends JFrame {

	private JPanel contentPane;
	private JTextArea textArea;
	private JPanel leftPanel;
	private JPanel bottomPanel;
	private JLabel lblNewLabel;
	private JTextField nameTextField;
	private JLabel lblBirtrhRate;
	private JTextField bRateTextField;
	private JLabel lblDeathRate;
	private JTextField dRateTextField;
	private JLabel lblMigrationBalance;
	private JTextField mBalanceTextField;
	private JButton btnAdd;
	private JButton btnSave;
	private JButton btnDelete;

	private ArrayList<Region> regions = new ArrayList<>();
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					RegionsGUI frame = new RegionsGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public RegionsGUI() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		contentPane.add(getTextArea(), BorderLayout.CENTER);
		contentPane.add(getLeftPanel(), BorderLayout.WEST);
		contentPane.add(getBottomPanel(), BorderLayout.SOUTH);
	}

	private JTextArea getTextArea() {
		if (textArea == null) {
			textArea = new JTextArea();
		}
		return textArea;
	}
	private JPanel getLeftPanel() {
		if (leftPanel == null) {
			leftPanel = new JPanel();
			leftPanel.setPreferredSize(new Dimension(120, 10));
			leftPanel.add(getLblNewLabel());
			leftPanel.add(getNameTextField());
			leftPanel.add(getLblBirtrhRate());
			leftPanel.add(getBRateTextField());
			leftPanel.add(getLblDeathRate());
			leftPanel.add(getDRateTextField());
			leftPanel.add(getLblMigrationBalance());
			leftPanel.add(getMBalanceTextField());
		}
		return leftPanel;
	}
	private JPanel getBottomPanel() {
		if (bottomPanel == null) {
			bottomPanel = new JPanel();
			bottomPanel.setPreferredSize(new Dimension(10, 30));
			bottomPanel.add(getBtnAdd());
			bottomPanel.add(getBtnSave());
			bottomPanel.add(getBtnDelete());
		}
		return bottomPanel;
	}
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("Name:");
		}
		return lblNewLabel;
	}
	private JTextField getNameTextField() {
		if (nameTextField == null) {
			nameTextField = new JTextField();
			nameTextField.setColumns(10);
		}
		return nameTextField;
	}
	private JLabel getLblBirtrhRate() {
		if (lblBirtrhRate == null) {
			lblBirtrhRate = new JLabel("Birtrh rate:");
		}
		return lblBirtrhRate;
	}
	private JTextField getBRateTextField() {
		if (bRateTextField == null) {
			bRateTextField = new JTextField();
			bRateTextField.setColumns(10);
		}
		return bRateTextField;
	}
	private JLabel getLblDeathRate() {
		if (lblDeathRate == null) {
			lblDeathRate = new JLabel("Death rate:");
		}
		return lblDeathRate;
	}
	private JTextField getDRateTextField() {
		if (dRateTextField == null) {
			dRateTextField = new JTextField();
			dRateTextField.setColumns(10);
		}
		return dRateTextField;
	}
	private JLabel getLblMigrationBalance() {
		if (lblMigrationBalance == null) {
			lblMigrationBalance = new JLabel("Migration balance:");
		}
		return lblMigrationBalance;
	}
	private JTextField getMBalanceTextField() {
		if (mBalanceTextField == null) {
			mBalanceTextField = new JTextField();
			mBalanceTextField.setColumns(10);
		}
		return mBalanceTextField;
	}
	private JButton getBtnAdd() {
		if (btnAdd == null) {
			btnAdd = new JButton("Add");
			btnAdd.setPreferredSize(new Dimension(65, 23));
		}
		return btnAdd;
	}
	private JButton getBtnSave() {
		if (btnSave == null) {
			btnSave = new JButton("Save");
			btnSave.setPreferredSize(new Dimension(65, 23));
		}
		return btnSave;
	}
	private JButton getBtnDelete() {
		if (btnDelete == null) {
			btnDelete = new JButton("Delete");
		}
		return btnDelete;
	}
}
